#include "common.h"
#include "kmodule.h"
#include "idt.h"



void getIDT (PIOBUFFER pIoBuffer, PIO_STATUS_BLOCK pIoStatus) {

	if (pIoBuffer->outputBufferLength != sizeof (KernelCmd_GetIDT))
		pIoStatus->Status = STATUS_INVALID_PARAMETER;


	KernelCmd_GetIDT *out = (KernelCmd_GetIDT*)pIoBuffer->pOutputBuffer;


	IDTR idtr;

	_asm sidt idtr;

	out->idtBaseVA = idtr.base;
	out->idtSize = idtr.limit;

	pIoStatus->Status = STATUS_SUCCESS;
	pIoStatus->Information = sizeof (KernelCmd_GetIDT);
}

