#pragma once

#ifndef _NTDDK_
extern "C" {
#include <winioctl.h>
}
#endif

//the following IDs should be system-wide unique
#define SVV_DEVICE_NAME (L"\\Device\\SVV2")
#define SVV_DEVICE_LINK (L"\\??\\SVV2")
#define SVV_USERLAND_DEV_NAME (L"\\\\.\\SVV2")

#define FILE_DEVICE_SVV  FILE_DEVICE_DISK_FILE_SYSTEM // allow only Admin & System access
//end of system-wide unique IDs

#define IOCTL_SVV_AQQ (ULONG) CTL_CODE(FILE_DEVICE_SVV,\
	0x800, METHOD_BUFFERED, FILE_READ_ACCESS | FILE_WRITE_ACCESS)

#define IOCTL_SVV_READ_VIRTUAL_MEMORY (ULONG) CTL_CODE(FILE_DEVICE_SVV,\
	0x801, METHOD_BUFFERED, FILE_READ_ACCESS | FILE_WRITE_ACCESS)

#define IOCTL_SVV_WRITE_VIRTUAL_MEMORY (ULONG) CTL_CODE(FILE_DEVICE_SVV,\
	0x802, METHOD_BUFFERED, FILE_READ_ACCESS | FILE_WRITE_ACCESS)

#define IOCTL_SVV_GET_SDT (ULONG) CTL_CODE(FILE_DEVICE_SVV,\
	0x803, METHOD_BUFFERED, FILE_READ_ACCESS | FILE_WRITE_ACCESS)

#define IOCTL_SVV_GET_IDT (ULONG) CTL_CODE(FILE_DEVICE_SVV,\
	0x804, METHOD_BUFFERED, FILE_READ_ACCESS | FILE_WRITE_ACCESS)

#define IOCTL_SVV_GET_MSR (ULONG) CTL_CODE(FILE_DEVICE_SVV,\
	0x805, METHOD_BUFFERED, FILE_READ_ACCESS | FILE_WRITE_ACCESS)


struct KernelCmd_ReadVirtualMem {
	DWORD address;
	DWORD len;		// no of bytes to read
};

	
struct KernelCmd_WriteVirtualMem {
	DWORD address;
	DWORD len;		// no of bytes to write
	BYTE buffer[1];
};



typedef struct _SYSTEM_SERVICE_TABLE {
	DWORD serviceTblAddr;
	DWORD counterTblAddr;
	DWORD serviceLimit;
	DWORD argTbl;
} SYSTEM_SERVICE_TABLE, *PSYSTEM_SERVICE_TABLE;

typedef struct _SERVICE_DESCRIPTOR_TABLE {
	SYSTEM_SERVICE_TABLE ntoskrnl;
	SYSTEM_SERVICE_TABLE win32k;
	SYSTEM_SERVICE_TABLE tbl3;
	SYSTEM_SERVICE_TABLE tbl4;
} SERVICE_DESCRIPTOR_TABLE, *PSERVICE_DESCRIPTOR_TABLE;

struct KernelCmd_GetSDT {
	SERVICE_DESCRIPTOR_TABLE sdt;
};

struct KernelCmd_GetIDT {
	DWORD idtBaseVA;
	DWORD idtSize;
};

struct KernelCmd_GetMSRs {
	DWORD SYSENTER_CS;
	DWORD SYSENTER_EIP;
	DWORD SYSENTER_ESP;

};



#define aqqQuestion ("alamakota")
#define aqqAnswer ("sierotkamarysia")
