#include "common.h"
#include "kmodule.h"
#include "sdt.h"


__declspec(naked) DWORD read32bitMSR (DWORD addr) {
	_asm {
		//int 3
		mov ecx, [esp+4]
		rdmsr
		ret 4
	}
	
}


void getMSRs (PIOBUFFER pIoBuffer, PIO_STATUS_BLOCK pIoStatus) {

	if (pIoBuffer->outputBufferLength != sizeof (KernelCmd_GetMSRs))
		pIoStatus->Status = STATUS_INVALID_PARAMETER;


	KernelCmd_GetMSRs *out = (KernelCmd_GetMSRs*)pIoBuffer->pOutputBuffer;



	out->SYSENTER_CS = read32bitMSR (0x174);
	out->SYSENTER_ESP = read32bitMSR (0x175);
	out->SYSENTER_EIP = read32bitMSR (0x176);
	pIoStatus->Status = STATUS_SUCCESS;
	pIoStatus->Information = sizeof (KernelCmd_GetMSRs);
}

