#include "common.h"
#include "kmodule.h"
#include "sdt.h"
extern "C" {
extern PSERVICE_DESCRIPTOR_TABLE KeServiceDescriptorTable;
}
void getSDT (PIOBUFFER pIoBuffer, PIO_STATUS_BLOCK pIoStatus) {

	if (pIoBuffer->outputBufferLength != sizeof (KernelCmd_GetSDT))
		pIoStatus->Status = STATUS_INVALID_PARAMETER;


	KernelCmd_GetSDT *out = (KernelCmd_GetSDT*)pIoBuffer->pOutputBuffer;

	__try {
	memcpy ((PVOID)&out->sdt, (PVOID)KeServiceDescriptorTable, 
		sizeof (SERVICE_DESCRIPTOR_TABLE));

	} __except (EXCEPTION_EXECUTE_HANDLER) {
		KdPrint (("Exception when reading KeServiceDescriptorTable!!!\n"));
		pIoStatus->Status = STATUS_INVALID_ADDRESS;
		return;
	}

	KdPrint (("KeServiceDescriptorTable = %#x\n", KeServiceDescriptorTable));
	pIoStatus->Status = STATUS_SUCCESS;
	pIoStatus->Information = sizeof (*out);
}

