#pragma once

#include "common.h"
#include <windows.h>

#define SVV_DRV_NAME (L"SVV")
#define SVV_DRV_DISPLAY_NAME (L"SVV kernel agent")


#include "..\\svvkernel\\kmodule.h"

class KernelAgent {
public:
	KernelAgent (WCHAR *drvPath);
	~KernelAgent();
	bool init ();

	
	bool loadDriver();
	bool unloadDriver();
	bool isDriverOk ();
	bool isDriverLoaded() { return driverLoaded; }


	bool readVirtualMemory (
		DWORD address,
		PVOID buffer,
		DWORD len,
		DWORD *bRead);
	
	bool writeVirtualMemory (
		DWORD address,
		PVOID buffer,
		DWORD len);

	bool getSDT();
	bool getIDT();
	bool getMSRs();

	bool isAddrInsideServiceTbl (DWORD addr);
	
private:
	bool sendCmdToKernelModule (
		DWORD cmd,
		PVOID inBuff,
		DWORD inBuffLen,
		PVOID outBuff,
		DWORD outBuffLen,
		DWORD *bytesReturned = NULL);

public:
	MEMORYSTATUSEX memoryStatusBlock;



	DWORD SYSENTER_EIP;

	DWORD IDTbaseVA;
	DWORD IDTsize;

	DWORD currKiServiceTblStart;
	DWORD currKiServiceTblEnd;
	
	DWORD origKiServiceTblStart;
	DWORD origKiServiceTblEnd;

private:
	
	WCHAR driverPath[MAX_PATH_LEN];
	bool driverLoaded;    

};


