#include "ntdll.h"
#include "debug.h"

NTQUERYSYSTEMINFORMATION ntQuerySystemInformation;
bool loadNtDllFunctions() {
	HMODULE hNtdll = LoadLibrary( "ntdll.dll" );
	if ( !hNtdll ) {
		DWORD err = GetLastError ();
		_debug ("LoadLibrary(NTDLL.DLL) Error:%d\n", err);
		SetLastError (err);
		return false;
	}

	ntQuerySystemInformation = (NTQUERYSYSTEMINFORMATION)
		GetProcAddress( hNtdll, "NtQuerySystemInformation");
	if (!ntQuerySystemInformation) {
		DWORD err = GetLastError ();
		_debug ("Cannot load NtQuerySystemInformation(), err = %#x", err);
		SetLastError (err);
		return false;
	}

	return true;
}