#pragma once

#include <windows.h>

class PEFile {
public:	
	PEFile (HANDLE fileHandle = NULL);
	~PEFile () ;

	void setFileHandle (HANDLE fileHandle) {hFile = fileHandle;}
	bool load();
	bool loadRelocTable();
	IMAGE_SECTION_HEADER* findSectionByName (char *sectName);
	IMAGE_SECTION_HEADER* findSectionByRVA (DWORD RVA);

	bool relocBuffer(DWORD start, DWORD end, DWORD sectionRVA, DWORD relOffset);

	bool findNearestExportedSymbol (DWORD RVA, 
		DWORD maxDistance, DWORD *distance,
		char *exportedName, DWORD exportedNameMaxLen);


	DWORD findExportedSymbol (const char *symName);

	bool RVA2fileOffset (DWORD RVA, DWORD *fileOffset);


	bool readBytes (DWORD offset, PBYTE buf, DWORD len);

public:
	IMAGE_DOS_HEADER dosHdr;
	IMAGE_NT_HEADERS32 ntHdr;
	DWORD noOfSections;
	IMAGE_SECTION_HEADER *sectHdrs;
	IMAGE_EXPORT_DIRECTORY exports;
//	IMAGE_IMPORT_DESCRIPTOR imports;

	DWORD *EAT, *ENT;
	WORD *EOT;


	DWORD IATStartRva, IATEndRva;	// all IAT tables
	DWORD EATStartRva, EATEndRva;

	PBYTE relocTable;
	DWORD relocTableSz;


private:
	HANDLE hFile;


};
