#pragma once

#include "common.h"
#include "kernelagent.h"
#include "module.h"
#include "verdict.h"
#include <windows.h>

class SystemVirginityVerifier {
public:
	
	SystemVirginityVerifier ();	
	~SystemVirginityVerifier ();

	bool init (WCHAR *abrdDriverPath);

	bool getListOfKernelModules ();
	bool getListOfUsermodeModulesInCurrentProcess ();
	void createOneListOfModules();

	Module* findModuleByAddr (DWORD addres);
	bool loadDriver ();
	bool unloadDriver ();


	SystemVerdict verdict (bool *disinfectionPossible);

	DWORD findKiServiceTableRVA (PEFile *ntpe);


	bool verifyKernelIDT ();
	bool verifyKernelMSRs ();



private:
	bool loadMandatoryDLLs();
	bool checkForMandatoryModules();
	bool isKernelModuleImportant(DWORD base);
	bool isUsermodeModuleImportant(DWORD base);

public:
	struct modulesTable {
		Module *tbl;
		DWORD count;
	} kernelModules, currProcModules;
	
	struct modulesPtrs {
		Module** ptrTbl;
		DWORD count;
	} modules;	// combined list for convenience
		
	bool *impKrnlModPresent, *impUsrmdModPresent;
	DWORD noOfImpKernelMods, noOfImpUsermodeMods;
	WCHAR **importantKernelModuleNames, **importantUsermodeModuleNames;

	Module *ntoskrnlModule;

	KernelAgent *kernelAgent;

	bool diagnosticMode;
};
