#pragma once

typedef enum _SystemVerdict {

	/* this is invalid verdict, meaning INTERNAL ERROR */
	INVALID_VERDICT = -1,

	/* 
	100% clean!
	unlikely to occur because of ntoskrnl self modifications
	but just for completeness ;)
	*/
	VERDICT_BLUE = 0,

	/* 
	only changes excluded by exclusion filter
	system is clean 
	(most common case on clean systems)
	*/
	VERDICT_GREEN,

	/* 
	hooking allowed by heuristics (Personal Firewalls, etc..)
	it is also possible that system is infected by a rootkit, though very unlikely
	*/
	VERDICT_YELLOW,

	/* 
	hooking allowed by heuristics (Personal Firewalls, etc..)
	LESS strict heuristics are use here, resulting in
	1) less false positives (for e.g. some tracing tools like RegMon)
	2) possibility to overlook some rootkits
	*/
	VERDICT_ORANGE,

	/*
	PROBABLY INFECTED!
	but may be a false positive (unknown self modifications of ntoskrnl.exe)
	disinfection should require HUMAN INVESTIGATION
	*/
	VERDICT_RED,

	/*
	SYSTEM INFECTED!
	very high risk of infection
	automatic disinfection should be performed!
	*/
	VERDICT_DEEPRED

} SystemVerdict;
